TagLib::ID3v2::ChapterFrame Class Reference

An implementation of ID3v2 chapter frames. More...

`#include <chapterframe.h>`

Inheritance diagram for TagLib::ID3v2::ChapterFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::ChapterFrame:
[legend]

## Public Member Functions

| ChapterFrame (const ID3v2::Header *tagHeader, const ByteVector &data)
| ChapterFrame (const ByteVector &elementID, unsigned int startTime, unsigned int endTime, unsigned int startOffset, unsigned int endOffset, const FrameList &embeddedFrames=FrameList())
| ~ChapterFrame () override
| ChapterFrame (const ChapterFrame &)=delete
ChapterFrame & | operator= (const ChapterFrame &)=delete
ByteVector | elementID () const
unsigned int | startTime () const
unsigned int | endTime () const
unsigned int | startOffset () const
unsigned int | endOffset () const
void | setElementID (const ByteVector &eID)
void | setStartTime (const unsigned int &sT)
void | setEndTime (const unsigned int &eT)
void | setStartOffset (const unsigned int &sO)
void | setEndOffset (const unsigned int &eO)
const FrameListMap & | embeddedFrameListMap () const
const FrameList & | embeddedFrameList () const
const FrameList & | embeddedFrameList (const ByteVector &frameID) const
void | addEmbeddedFrame (Frame *frame)
void | removeEmbeddedFrame (Frame *frame, bool del=true)
void | removeEmbeddedFrames (const ByteVector &id)
String | toString () const override
PropertyMap | asProperties () const override
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
| Frame (const Frame &)=delete
Frame & | operator= (const Frame &)=delete
ByteVector | frameID () const
unsigned int | size () const
unsigned int | headerSize () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual StringList | toStringList () const
ByteVector | render () const
Header * | header () const

## Static Public Member Functions

static ChapterFrame * | findByElementID (const Tag *tag, const ByteVector &eID)
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static ByteVector | textDelimiter (String::Type t)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)

## Protected Member Functions

void | parseFields (const ByteVector &data) override
ByteVector | renderFields () const override
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=nullptr)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const

## Friends

class | FrameFactory

## Additional Inherited Members

Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An implementation of ID3v2 chapter frames.

This is an implementation of ID3v2 chapter frames. The purpose of this frame is to describe a single chapter within an audio file.

## Constructor & Destructor Documentation

## ChapterFrame() [1/3]

TagLib::ID3v2::ChapterFrame::ChapterFrame | ( | const ID3v2::Header * | tagHeader,
|  | const ByteVector & | data )

Creates a chapter frame based on data. tagHeader is required as the internal frames are parsed based on the tag version.

Referenced by ChapterFrame(), findByElementID(), operator=(), and renderFields().

## ChapterFrame() [2/3]

TagLib::ID3v2::ChapterFrame::ChapterFrame | ( | const ByteVector & | elementID,
|  | unsigned int | startTime,
|  | unsigned int | endTime,
|  | unsigned int | startOffset,
|  | unsigned int | endOffset,
|  | const FrameList & | embeddedFrames = FrameList() )

Creates a chapter frame with the element ID elementID, start time startTime, end time endTime, start offset startOffset, end offset endOffset and optionally a list of embedded frames, whose ownership will then be taken over by this Frame, in embeddedFrames.

All times are in milliseconds.

References elementID(), endOffset(), endTime(), startOffset(), and startTime().

## ~ChapterFrame()

TagLib::ID3v2::ChapterFrame::~ChapterFrame | ( |  | ) |

override

Destroys the frame.

## ChapterFrame() [3/3]

TagLib::ID3v2::ChapterFrame::ChapterFrame | ( | const ChapterFrame & |  | ) |

delete

References ChapterFrame().

## Member Function Documentation

## addEmbeddedFrame()

void TagLib::ID3v2::ChapterFrame::addEmbeddedFrame | ( | Frame * | frame | ) |

Add an embedded frame to the CHAP frame. At this point the CHAP frame takes ownership of the embedded frame and will handle freeing its memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

References TagLib::ID3v2::Frame::Frame().

## asProperties()

PropertyMap TagLib::ID3v2::ChapterFrame::asProperties | ( |  | ) | const

override virtual

Parses the contents of this frame as PropertyMap. If that fails, the returned PropertyMap will be empty, and its unsupportedData() will contain this frame's ID.

Reimplemented from TagLib::ID3v2::Frame.

## elementID()

ByteVector TagLib::ID3v2::ChapterFrame::elementID | ( |  | ) | const

Returns the element ID of the frame. Element ID is a null terminated string, however it's not human-readable.

See also
  setElementID()

Referenced by ChapterFrame().

## embeddedFrameList() [1/2]

const FrameList & TagLib::ID3v2::ChapterFrame::embeddedFrameList | ( |  | ) | const

Returns a reference to the embedded frame list. This is a FrameList of all of the frames embedded in the CHAP frame in the order that they were parsed.

This can be useful if for example you want to iterate over the CHAP frame's embedded frames in the order that they occur in the CHAP frame.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

## embeddedFrameList() [2/2]

const FrameList & TagLib::ID3v2::ChapterFrame::embeddedFrameList | ( | const ByteVector & | frameID | ) | const

Returns the embedded frame list for frames with the id frameID or an empty list if there are no embedded frames of that type. This is just a convenience and is equivalent to:

embeddedFrameListMap()[frameID];
TagLib::ID3v2::ChapterFrame::embeddedFrameListMap
const FrameListMap & embeddedFrameListMap() const
TagLib::ID3v2::Frame::frameID
ByteVector frameID() const

See also
  embeddedFrameListMap()

References TagLib::ID3v2::Frame::frameID().

## embeddedFrameListMap()

const FrameListMap & TagLib::ID3v2::ChapterFrame::embeddedFrameListMap | ( |  | ) | const

Returns a reference to the frame list map. This is a FrameListMap of all of the frames embedded in the CHAP frame.

This is the most convenient structure for accessing the CHAP frame's embedded frames. Many frame types allow multiple instances of the same frame type so this is a map of lists. In most cases however there will only be a single frame of a certain type.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

See also
  embeddedFrameList()

## endOffset()

unsigned int TagLib::ID3v2::ChapterFrame::endOffset | ( |  | ) | const

Returns zero based byte offset (count of bytes from the beginning of the audio file) of chapter's end.

Note
  If the returned value is 0xFFFFFFFF, end time should be used instead.

See also
  setEndOffset()

Referenced by ChapterFrame().

## endTime()

unsigned int TagLib::ID3v2::ChapterFrame::endTime | ( |  | ) | const

Returns time of chapter's end (in milliseconds).

See also
  setEndTime()

Referenced by ChapterFrame().

## findByElementID()

ChapterFrame * TagLib::ID3v2::ChapterFrame::findByElementID | ( | const Tag * | tag,
|  | const ByteVector & | eID )

static

CHAP frames each have a unique element ID. This searches for a CHAP frame with the element ID eID and returns a pointer to it. This can be used to link CTOC and CHAP frames together.

See also
  elementID()

References ChapterFrame(), and TagLib::ID3v2::Frame::Tag.

## operator=()

ChapterFrame & TagLib::ID3v2::ChapterFrame::operator= | ( | const ChapterFrame & |  | ) |

delete

References ChapterFrame().

## parseFields()

void TagLib::ID3v2::ChapterFrame::parseFields | ( | const ByteVector & | data | ) |

override protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Implements TagLib::ID3v2::Frame.

## removeEmbeddedFrame()

void TagLib::ID3v2::ChapterFrame::removeEmbeddedFrame | ( | Frame * | frame,
|  | bool | del = true )

Remove an embedded frame from the CHAP frame. If del is `true` the frame's memory will be freed; if it is `false`, it must be deleted by the user.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

References TagLib::ID3v2::Frame::Frame().

## removeEmbeddedFrames()

void TagLib::ID3v2::ChapterFrame::removeEmbeddedFrames | ( | const ByteVector & | id | ) |

Remove all embedded frames of type id from the CHAP frame and free their memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## renderFields()

ByteVector TagLib::ID3v2::ChapterFrame::renderFields | ( |  | ) | const

override protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Implements TagLib::ID3v2::Frame.

References ChapterFrame(), and TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## setElementID()

void TagLib::ID3v2::ChapterFrame::setElementID | ( | const ByteVector & | eID | ) |

Sets the element ID of the frame to eID. If eID isn't null terminated, a null char is appended automatically.

See also
  elementID()

## setEndOffset()

void TagLib::ID3v2::ChapterFrame::setEndOffset | ( | const unsigned int & | eO | ) |

Sets zero based byte offset (count of bytes from the beginning of the audio file) of chapter's end to eO.

See also
  endOffset()

## setEndTime()

void TagLib::ID3v2::ChapterFrame::setEndTime | ( | const unsigned int & | eT | ) |

Sets time of chapter's end (in milliseconds) to eT.

See also
  endTime()

## setStartOffset()

void TagLib::ID3v2::ChapterFrame::setStartOffset | ( | const unsigned int & | sO | ) |

Sets zero based byte offset (count of bytes from the beginning of the audio file) of chapter's start to sO.

See also
  startOffset()

## setStartTime()

void TagLib::ID3v2::ChapterFrame::setStartTime | ( | const unsigned int & | sT | ) |

Sets time of chapter's start (in milliseconds) to sT.

See also
  startTime()

## startOffset()

unsigned int TagLib::ID3v2::ChapterFrame::startOffset | ( |  | ) | const

Returns zero based byte offset (count of bytes from the beginning of the audio file) of chapter's start.

Note
  If the returned value is 0xFFFFFFFF, start time should be used instead.

See also
  setStartOffset()

Referenced by ChapterFrame().

## startTime()

unsigned int TagLib::ID3v2::ChapterFrame::startTime | ( |  | ) | const

Returns time of chapter's start (in milliseconds).

See also
  setStartTime()

Referenced by ChapterFrame().

## toString()

String TagLib::ID3v2::ChapterFrame::toString | ( |  | ) | const

override virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Implements TagLib::ID3v2::Frame.

## Friends And Related Symbol Documentation

## FrameFactory

friend class FrameFactory

friend

References FrameFactory.

Referenced by FrameFactory.

The documentation for this class was generated from the following file:

- chapterframe.h